BASE_SKIP_CLASSES = 1
include \masm32\ultrano\bank\base.inc

;=====<< Benchmarking macros START_TEST/END_TEST >>===\
TEST_ITERS equ 100000
TEST_ID = 0


START_TEST macro where:REQ
	@START_TEST_VAR textequ <where>
	mov where,-1
	;invoke GetModuleHandle,0
	;invoke SetPriorityClass,eax,REALTIME_PRIORITY_CLASS
	
	TEST_ID = TEST_ID + 1
	rdtsc
	push eax
	mov ecx,TEST_ITERS
	align 16
	@CatStr(<testlabl>,%TEST_ID,<:>)
endm
END_TEST macro
	dec ecx
	jnz @CatStr(<testlabl>,%TEST_ID)
	rdtsc
	pop edx
	sub eax,edx
	xor edx,edx
	mov ecx,TEST_ITERS
	div ecx
	.if eax<@START_TEST_VAR
		mov @START_TEST_VAR,eax
	.endif
	;invoke GetModuleHandle,0
	;invoke SetPriorityClass,eax,NORMAL_PRIORITY_CLASS
	
	;print @START_TEST_VAR
endm
;=======/

someproc proc p1,p2,p3,p4,p5
	;mov eax,p1
	;add eax,p2
	;add eax,p3
	;add eax,p4
	;add eax,p5
	
	ret
someproc endp


main proc
	local time1,time2
	local time3,time4,time5
	
	;----[ warm-up ]-----------\
	START_TEST time2
	invoke someproc,1,2,3,4,5
	END_TEST
	invoke GetModuleHandle,0
	invoke SetPriorityClass,eax,REALTIME_PRIORITY_CLASS
	invoke Sleep,300
	;--------------------------/
	
	;----[ test imm params ]------\
	START_TEST time1
	sub esp,20
	mov dword ptr [esp+16],5
	mov dword ptr [esp+12],4
	mov dword ptr [esp+8],3
	mov dword ptr [esp+4],2
	mov dword ptr [esp],1
	call someproc
	END_TEST
	
	
	START_TEST time2
	invoke someproc,1,2,3,4,5
	END_TEST
	;------------------------------/
	
	;----[ test reg params ]----------\
	START_TEST time3
	sub esp,20
	mov dword ptr [esp+16],eax
	mov dword ptr [esp+12],ebx
	mov dword ptr [esp+8],ecx
	mov dword ptr [esp+4],edx
	mov dword ptr [esp],esi
	call someproc
	END_TEST
	
	START_TEST time4
	invoke someproc,esi,edx,ecx,ebx,eax
	END_TEST
	;---------------------------------/
	
	
	;------[ test var params ]------\
	START_TEST time5
	invoke someproc,time1,time2,time3,time4,time5
	END_TEST
	;-------------------------------/
	
	
	trace "IMM: %d vs %d",time1,time2
	trace "REG: %d vs %d",time3,time4
	trace "VAR: %d",time5
	
	ret
main endp



start:
	invoke main
	invoke ExitProcess,0
end start
